-- 
--      Students
--
--     Students
-- INSERT INTO students SELECT * FROM generate_students_data();
--
CREATE OR REPLACE FUNCTION generate_students_data()
  RETURNS TABLE( mark_book numeric( 5 ), name text, psp_ser numeric( 4 ),
                 psp_num numeric( 6 ) ) AS
$$
BEGIN
  --     mark_book, psp_ser, psp_num.

  --   "  "   .
  CREATE TEMP SEQUENCE New_mark_book START WITH 10000;

  --   " "   .
  CREATE TEMP SEQUENCE New_psp_ser START WITH 1000;

  --   " "   .
  CREATE TEMP SEQUENCE New_psp_num START WITH 100000;

  RETURN QUERY
  SELECT NEXTVAL( 'New_mark_book' )::numeric( 5 ),
         lname_base || lname_suffix || ' ' || fname || ' ' || pname,
         NEXTVAL( 'New_psp_ser' )::numeric( 4 ),
         NEXTVAL( 'New_psp_num' )::numeric( 6 )
  --     ,   ,
  -- . .        
  --       .
  FROM ( VALUES ( '' ), ( '' ), ( '' ), ( '' ) )
           AS lname_bases ( lname_base ) NATURAL JOIN 
       ( VALUES ( '' ), ( '' ), ( '' ), ( '' ), ( '' ) )
           AS lname_suffixes ( lname_suffix ) NATURAL JOIN 
       ( VALUES ( '' ), ( '' ), ( '' ), ( '' ) )
           AS fnames ( fname ) NATURAL JOIN
       ( VALUES ( '' ), ( '' ), ( '' ),
                ( '' ) ) 
           AS pnames ( pname );

  --   .
  DROP SEQUENCE New_mark_book;
  DROP SEQUENCE New_psp_ser;
  DROP SEQUENCE New_psp_num;
END
$$ LANGUAGE plpgsql;
