-- ----------------------------------------------------------------------------------
--   
-- (.    PostgreSQL, . 39.9 "Trigger Procedures")
-- ----------------------------------------------------------------------------------

--    
DROP TABLE IF EXISTS students ;
CREATE TABLE students 
( mark_book numeric(5) NOT NULL,
  name text NOT NULL,
  psp_ser numeric(4),
  psp_num numeric(6),
  PRIMARY KEY ( mark_book )
);

--    (     ,    ,
--    )
--      ,    
DROP TABLE IF EXISTS students_2;
CREATE TABLE students_2 
( mark_book numeric(5),
  name text,
  psp_ser numeric(4),
  psp_num numeric(6),
  --   ()
  operation text,    --   (INSERT, UPDATE, DELETE)
  person text,       -- ,  
  moment timestamp   --  ,    
);
  
--   (   ,    )
CREATE OR REPLACE FUNCTION log_students() RETURNS TRIGGER 
AS $log_students_oper$
  BEGIN
    -- TG_OP --    PL/pgSQL, 
    --       
    IF TG_OP = 'INSERT' THEN
      -- NEW --  ,    students
      -- user -- ,    ,  
      --         
      -- current_timestamp -- ,    
      INSERT INTO students_2 VALUES ( NEW.*, TG_OP, user, current_timestamp );
      RETURN NEW;  --      NEW
    ELSIF TG_OP = 'UPDATE' THEN
      INSERT INTO students_2 VALUES ( NEW.*, TG_OP, user, current_timestamp );
      RETURN NEW;  --      NEW
    ELSIF TG_OP = 'DELETE' THEN
      INSERT INTO students_2 VALUES ( OLD.*, TG_OP, user, current_timestamp );
      RETURN OLD;  --      OLD
    END IF;
    RETURN NULL;   --  , ..   
                   --      students
                   -- (AFTER trigger)
  END;
$log_students_oper$ LANGUAGE plpgsql;   --  PL/pgSQL 

--      log_students()
--     ,    
-- (FOR EACH ROW)
CREATE TRIGGER log_students_oper 
  AFTER INSERT OR UPDATE OR DELETE ON students 
  FOR EACH ROW EXECUTE PROCEDURE log_students();

--    ,      
--   (      2013, 
--      date_part,   
--  )
CREATE OR REPLACE FUNCTION check_mark_book() RETURNS TRIGGER AS $check_mb$
  BEGIN

    --      
    IF NEW.mark_book < 10000 THEN
      --         INSERT 
      --  UPDATE
      RAISE EXCEPTION '     ';
    END IF;

    --          13
    -- (  --  )
    --  mod()        
    --    100     
    IF mod( NEW.mark_book, 100 ) <> 13 THEN
      --         INSERT
      --  UPDATE
      RAISE EXCEPTION '    ' ||
                      '   ';
    END IF;

    --   ,        
    --  
    RETURN NEW;
  END;
$check_mb$ LANGUAGE plpgsql;

--      check_mark_book()
CREATE TRIGGER check_mb
  BEFORE INSERT OR UPDATE ON students 
  FOR EACH ROW EXECUTE PROCEDURE check_mark_book();
