-- ----------------------------------------------------------------------------
-- SQL-команды, иллюстрирующие метод Adjacency List (список смежности)
-- ----------------------------------------------------------------------------


-- ----------------------------------------------------------------------------
-- Создание базы данных и хранимых процедур
-- (команды выполнять в командной строке операционной системы)
-- ----------------------------------------------------------------------------
createdb hier
psql -d hier -f adj_list.sql

-- ----------------------------------------------------------------------------
-- Выборка из таблицы "Персонал"
-- (эту и другие команды выполнять в командной строке операционной системы
--  следующим образом:
--  psql -d hier -с "SELECT * FROM Personnel"
-- )
-- ----------------------------------------------------------------------------
SELECT * FROM Personnel;

-- ----------------------------------------------------------------------------
-- Выборка из таблицы "Организационная структура"
-- ----------------------------------------------------------------------------
SELECT * FROM Org_chart;

-- ----------------------------------------------------------------------------
-- Проверка структуры дерева на предмет отсутствия циклов
-- ----------------------------------------------------------------------------
SELECT * FROM tree_test();

-- ----------------------------------------------------------------------------
-- Обход дерева организационной структуры снизу вверх, начиная с конкретного
-- узла (параметром процедуры является код работника)
-- ----------------------------------------------------------------------------
SELECT * FROM up_tree_traversal( 1 );
SELECT * FROM up_tree_traversal( 2 );
SELECT * FROM up_tree_traversal2( 4 ) AS (emp int, boss int);
SELECT * FROM up_tree_traversal2( 6 ) AS (emp int, boss int);

-- ----------------------------------------------------------------------------
-- Удаление поддерева
-- (параметром процедуры является код работника)
-- ----------------------------------------------------------------------------
SELECT * FROM delete_subtree( 6 );

-- ----------------------------------------------------------------------------
-- Удаление элемента иерархии и продвижения
-- дочерних элементов на один уровень вверх (т. е. к "бабушке")
-- ----------------------------------------------------------------------------
SELECT * FROM delete_and_promote_subtree( 5 );

-- ----------------------------------------------------------------------------
-- Реконструирование организационной структуры 
-- ----------------------------------------------------------------------------
SELECT * FROM Personnel_org_chart;

-- ----------------------------------------------------------------------------
-- Построение всех путей сверху дерева вниз
-- (только для четырех уровней иерархии)
-- ----------------------------------------------------------------------------
SELECT * FROM Create_paths;

